
//////////////////////////////////////////////////////////////////
//Mandelbrotmenge mit Hardware-Multitheading
/////////////////////////////////////////////////////////////////

ArrayList<Threads> threads;
double xU = -2.5; 
double yU = -2; 
double xO = 1.5;
double yO = 2;
double wh = xO-xU;

int maxiterations = 4000;//nur zur Demo , 400 reichen
double massFuerUnendlich = 1000;//auch hier
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 

void setup() {
  background(255);
  noLoop();
  colorMode(HSB);
  threads = new  ArrayList<Threads>(); 
  size(800, 800);
  
 
  nummerThread =0;
  println("Anzahl Threads: "+anzahlThreads);
// starte anzahlThreads Threads
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);  
}
/////////////////////////////////////////////////////////////////

void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer){
  
  xU = px; yU = py;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;//println(wh/anzahlThreads); double y= yU;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <16){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(50);//zur Verringerung der Pixelfehler  
  } 
}
//////////////////////////////////////////////////////////////

void draw() {  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);   
  }       
}
/////////////////////////////////////////////////////////////////

void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     // berechne, wo der Mauszeiger im gezeigten Ausschnitt der komplexen
     // Zahlenebene ist (Transformation Pixelposition nach (x,y))
      xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
      xU = xUNeu; xO = xONeu; 
      //println(xU,xO);
      yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
      yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
      yU =yUNeu; yO = yONeu; 
      wh = wh/5;
      //println(xU,xO,yU,yO);
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);

     redraw();
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){
    maxiterations *= 1.2;
    threads = new  ArrayList<Threads>(); 
    starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == '-') {
    maxiterations /= 1.2;
    threads = new  ArrayList<Threads>(); 
    starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);  
  }
  if (key == 's') save("mandelbrot.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
