//Klasse Threads erbt von Thread die Methoden und  Attribute
class Threads extends Thread {
  
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int tN;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, int nummer) {
    // benötigte Parameter
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    pg = createGraphics(width,height/anzahlThreads);  
  }
//////////////////////////////////////////////////////////////////////////////////  
  public int gibNummer(){   
    return tN;   
  }
//////////////////////////////////////////////////////////////  
  public void run() {
    tN =this.gibNummer(); //println(tN);//Zur eventuellen Kontrolle
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //Information über Zuständigkeitsbereich der Threads
        println("Threadnummer: "+tN,"minimaler Y-Wert: "+ymin,"maximaler Y-Wert: "+ymax);
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            int n = mandelbrotIteration(x, y);           
            pg.pixels[i+j*pg.width] = colorize(n);
            
            /*Koordinatenachsen:  
            if (((x<=0.01) && (x+dx>0.01)) || ((y<=0.01) && (y+dy>0.01)))
                pg.pixels[i+j*pg.width] = color(0,0,50);  */
            
            //Zeigt die Bildbereiche an, für die je ein Core zustänig ist
            if(y >= ymax-0.01)
                pg.pixels[i+j*pg.width] = color(0);  
                
            x += dx; //if(tN==0 && y==0) println(x);
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;   
  }  
/////////////////////////////////////////////////////////////////////
int mandelbrotIteration(double x, double y) {

  // nun wird für eine komplexe Zahl bzw. einen Punkt der Ebene getestet, 
  // wohin er bei der Iteration geht. Je nachdem wird er dann später ein-
  // gefärbt
  double a = x;
  double b = y;
  int n = 0;
  while (n < maxiterations) {
    double aa = a * a;
    double bb = b * b;
    double twoab = 2.0 * a * b;
    a = aa - bb  + x;
    b = twoab + y;
    
    if (aa + bb > massFuerUnendlich) {
      break;  // Bail
    }
    n++;
  }
  return n;
 }
/////////////////////////////////////////////////////////////
color colorize(int n) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
  // bis entweder der Wert der komplexen Zahl Null oder über einer
  // Schwelle ist
  if (n == maxiterations){
    return color(0, 0, 0);
  }else{
   color col = color(255*n/maxiterations,255,255);
    return col; 
  }
 }
}
